/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// L_MAIN_PROCESS.cpp: implementation of the CL_MAIN_PROCESS class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "L_MAIN_PROCESS.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CL_MAIN_PROCESS::CL_MAIN_PROCESS()
{

}

CL_MAIN_PROCESS::~CL_MAIN_PROCESS()
{

}


int 
CL_MAIN_PROCESS::
populate_process_list(	
						CL_PROCESS_DETAILS *arg_process_list)
{
	unsigned long aProcesses[1024], cbNeeded, cProcesses;
    unsigned int i;

    if ( !EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) )
        return 0;

    // Calculate how many process identifiers were returned.

    cProcesses = cbNeeded / sizeof(DWORD);

    // Print the name and process identifier for each process.

	int j = 0;
    for ( i = 0; i < cProcesses; i++ )
	{
        if(populate_process_details( 
									arg_process_list[i],
									aProcesses[j++]) == -1)
		{
			--i;
			--cProcesses;
		}
	}

	return cProcesses;
}


int 
CL_MAIN_PROCESS::
populate_process_details(	
								CL_PROCESS_DETAILS &arg_process_detail,
								long arg_process_id)
{
	char szProcessName[M_MAX_PATH] = "unknown";

    // Get a handle to the process.
    HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                   PROCESS_VM_READ |
								   PROCESS_TERMINATE,
                                   FALSE,
								   arg_process_id );

    // Get the process name.
    if ( hProcess )
    {
        HMODULE hMod;
        DWORD cbNeeded;
		int n_f_size;
        if ( EnumProcessModules( hProcess, &hMod, sizeof(hMod), 
             &cbNeeded) )
        {
			n_f_size =
            GetModuleBaseName(	hProcess, 
								hMod, 
								szProcessName, 
								sizeof(szProcessName));
			
			if(n_f_size <= 0)
			{
				CloseHandle( hProcess );
				return -1;
			}

			/*n_f_size = 
			GetModuleFileNameEx(	hProcess, 
									hMod,
									szProcessName, 
									sizeof(szProcessName));*/
        }
		else
			return -1;
    }
	else
	{
		hProcess = OpenProcess(	PROCESS_QUERY_INFORMATION |
								PROCESS_VM_READ ,
								FALSE,
								arg_process_id );
		if ( hProcess )
		{
			szProcessName[0] = '@';
			szProcessName[1] = '-';
			HMODULE hMod;
			DWORD cbNeeded;
			int n_f_size;
			if ( EnumProcessModules( hProcess, &hMod, sizeof(hMod), 
				 &cbNeeded) )
			{
				n_f_size =
				GetModuleBaseName(	hProcess, 
									hMod, 
									&szProcessName[2], 
									sizeof(szProcessName)-2);
			
				if(n_f_size <= 0)
				{
					CloseHandle( hProcess );
					return -1;
				}

				/*n_f_size = 
				GetModuleFileNameEx(	hProcess, 
										hMod,
										szProcessName, 
										sizeof(szProcessName));*/
			}
			else
				return -1;
		}
		else
			return -1;
	}

	arg_process_detail.m_n_process_id = arg_process_id;

	strcpy(
			arg_process_detail.m_sz_process_name,
			szProcessName);

    CloseHandle( hProcess );

	return 0;
}

int CL_MAIN_PROCESS::populate_file_list(	char* sz_path,
											CL_FILE_DETAILS *file_list)
{
	if( stricmp( "/", sz_path ) == 0)
	{
		char drv_buffer[513];
		int n_size = GetLogicalDriveStrings(	512,
												drv_buffer);
		int n_file_count = 0;
		if(n_size < 512 && n_size > 0)
		{
			for(int i = 0 ; i < n_size ; i+=4)
			{
				if (toupper(drv_buffer[i]) != 'A' && toupper(drv_buffer[i]) != 'B')
				{
					file_list[n_file_count].m_is_dir = 0;
					strncpy(	file_list[n_file_count].m_sz_file_name,
								&drv_buffer[i],
								2);
					file_list[n_file_count].m_sz_file_name[2] = '\0';

					++n_file_count;
				}
			}
		}
		return n_file_count;

	}
	else
	{
		WIN32_FIND_DATA find_file_data;
		HANDLE h_find = ::FindFirstFile(	sz_path,
											&find_file_data);

		int n_file_count = 0;
		int n_found = 1;
		if(h_find == INVALID_HANDLE_VALUE)
			n_found = 0;
		while(n_found)
		{
			if(find_file_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				file_list[n_file_count].m_is_dir = 1;
			else
				file_list[n_file_count].m_is_dir = 2;

			strcpy(	file_list[n_file_count].m_sz_file_name,
					find_file_data.cFileName);

			//Increment number of file count
			n_file_count++;

			n_found = ::FindNextFile(	h_find,
										&find_file_data);
		}
		return n_file_count;
	}
	return 0;
}

int CL_MAIN_PROCESS::get_files_count(char *sz_path)
{
	if( stricmp( "/", sz_path ) == 0)
	{
		char drv_buffer[513];
		int n_size = GetLogicalDriveStrings(	512,
												drv_buffer);
		int n_file_count = 0;
		if(n_size < 512 && n_size > 0)
		{
			for(int i = 0 ; i < n_size ; i+=4)
			{
				++n_file_count;
			}
		}
		return n_file_count;

	}
	else
	{
		WIN32_FIND_DATA find_file_data;
		HANDLE h_find = ::FindFirstFile(	sz_path,
											&find_file_data);

		int n_file_count = 0;
		int n_found = 1;
		if(h_find == INVALID_HANDLE_VALUE)
			n_found = 0;
		while(n_found)
		{
			n_file_count++;

			n_found = ::FindNextFile(	h_find,
										&find_file_data);
		}
		return n_file_count;
	}
	return 0;
}
