/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// L_REQUEST_FORMAT.cpp: implementation of the CL_REQUEST_FORMAT class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "L_REQUEST_FORMAT.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CL_REQUEST_FORMAT::CL_REQUEST_FORMAT()
{
}

CL_REQUEST_FORMAT::CL_REQUEST_FORMAT(	char *arg_data,
										int arg_len)
{
	strcpy(	m_sz_request_name,
			get_argument(1, arg_data));

	strcpy( m_sz_packed_data,
			&arg_data[	strlen(m_sz_request_name) + 5]
			);

}

CL_REQUEST_FORMAT::~CL_REQUEST_FORMAT()
{

}

char* CL_REQUEST_FORMAT::get_argument(int n_arg, char* data)
{
	if(data == NULL)
		data = m_sz_packed_data;
	int n_occurance = 0;
	int n_pos;
	int n_str_index = 0;
	if(n_arg <= 0)
		return NULL;
	while(n_occurance < n_arg)
	{
		n_pos = find_delim( &data[n_str_index], "|*|*|");
		if(n_pos <= 0)
			return NULL;
		else
		{
			++n_occurance;
			if(n_occurance == n_arg)
				break;
			n_str_index += (n_pos+5);
		}
	}
	char temp[MAX_REQUEST_DATA];
	temp[0] = '\0';
	strncpy(	temp,
				&data[n_str_index],
				n_pos);
	temp[n_pos] = '\0';
	return temp;
}

int CL_REQUEST_FORMAT::find_delim(char *sz_src, char *sz_delim)
{
	int n_delim_index = 0;
	int str_index = 0;
	bool found_char = false;
	int i;
	int src_len = strlen(sz_src);

	for( i = str_index; i < src_len; ++i )
	{
		if(sz_src[i] == sz_delim[n_delim_index])
		{
			n_delim_index++;
			found_char = true;
			if( n_delim_index >= strlen( sz_delim) )
				break;
		}
		else if(found_char == true)
		{
			n_delim_index = 0;
			str_index++;
			found_char = false;
		}
	}
	if(found_char)
		return i - strlen(sz_delim) + 1;
	else
		return -1;
}
