/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

#ifndef _SERV_INF_TRANS_ST_H
#define _SERV_INF_TRANS_ST_H

typedef struct _ST_FILE_DETAILS
{
	//Data members

	//File path
	char	m_sz_file_path[M_MAX_PATH * 2];
	//File name
	char	m_sz_file_name[M_MAX_PATH];
	//Attributes
	int		m_n_attributes;
	//Size of file in bytes
	long	m_n_size;
	//Time of last access
	time_t	m_time_access;
	//Time of last modification
	time_t	m_time_mod;
	//Time when file was created
	time_t	m_time_creat;

}ST_FILE_DETAILS;


typedef struct _ST_PROCESS_DETAILS
{
	//Data members

	//Process name
	char	m_sz_process_name[M_MAX_PATH];
	//Process ID
	int		m_n_process_id;

}ST_PROCESS_DETAILS;


typedef enum _Attribute
{
	normal =    0x00,
	readOnly =  0x01,
	hidden =    0x02,
	system =    0x04,
	volume =    0x08,
	directory = 0x10,
	archive =   0x20

}Attribute;


#endif
