/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// L_EXPLORER.cpp : implementation file
//

#include "stdafx.h"
#include "ReCClient.h"
#include "L_EXPLORER.h"
#include "L_GENERIC_SOCKET.h"
#include "L_FILE_DETAILS.h"
#include "L_COPY_PASTE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SOCKET g_sock_client;
extern bool g_is_connected;
/////////////////////////////////////////////////////////////////////////////
// CL_EXPLORER dialog

/****************Global Data**********************/
CTreeCtrl *DirTree;
/**************End Global Data********************/


CL_EXPLORER::CL_EXPLORER(CWnd* pParent /*=NULL*/)
	: CDialog(CL_EXPLORER::IDD, pParent)
{
	//{{AFX_DATA_INIT(CL_EXPLORER)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	b_is_copy = false;
	m_is_cut = false;
}


void CL_EXPLORER::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CL_EXPLORER)
	DDX_Control(pDX, IDC_FILE_LIST, m_file_list);
	DDX_Control(pDX, IDC_FILE_TREE, m_dir_tree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CL_EXPLORER, CDialog)
	//{{AFX_MSG_MAP(CL_EXPLORER)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_FILE_TREE, OnItemexpandingFileTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_FILE_TREE, OnSelchangedFileTree)
	ON_NOTIFY(NM_RCLICK, IDC_FILE_LIST, OnRclickFileList)
	ON_COMMAND(ID__COPY, OnCopy)
	ON_COMMAND(ID__CUT, OnCut)
	ON_COMMAND(ID__PASTE, OnPaste)
	ON_NOTIFY(NM_CLICK, IDC_FILE_LIST, OnClickFileList)
	ON_COMMAND(ID_MAIN_DELETE, OnMainDelete)
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	ON_BN_CLICKED(IDC_BTN_COPY_FROM, OnBtnCopyFrom)
	ON_BN_CLICKED(IDC_BTN_PASTE_TO, OnBtnPasteTo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CL_EXPLORER message handlers

void gFindAllFiles(CString szDir,HTREEITEM hParent, HTREEITEM hInsertAfter)
{
	CFileFind DirFind;
	CFileFind FileFind;
	CString szDirPath = "\\*.*";
//	CString szFilePath = "\\*.bat";
	CString szCurDir = szDir;

//	BOOL bContinueFile = FileFind.FindFile(szCurDir+szFilePath);
//	while(bContinueFile)
//	{
//		bContinueFile = FileFind.FindNextFile();
//		FileTxt.WriteString(FileFind.GetFilePath());
//		FileTxt.WriteString("\n");
//	}


	BOOL bContinueDir = DirFind.FindFile(szCurDir+szDirPath);
	while(bContinueDir)
	{
		bContinueDir = DirFind.FindNextFile();
		if(DirFind.IsDirectory() && !DirFind.IsDots())
		{
			CString szNewDir = DirFind.GetFilePath();
			CString szDirName = DirFind.GetFileName();
			HTREEITEM hTemp = DirTree->InsertItem(szDirName,hParent,hInsertAfter);
			gFindAllFiles(szNewDir,hTemp,TVI_LAST);
		}
	}
	DirTree->SortChildren(hParent);
}

BOOL CL_EXPLORER::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_file_list.SetExtendedStyle(LVS_EX_FULLROWSELECT);// | LVS_EX_GRIDLINES);
	m_file_list.InsertColumn(0,"File Name",LVCFMT_LEFT,250);

	CImageList* pImageList = new CImageList();
	pImageList->Create(16, 15, TRUE, 3, 2);

	CBitmap bitmap;
	for (UINT iCnt=IDB_BM_DRIVE; iCnt<=IDB_BMFILE; iCnt++)
	{
		bitmap.LoadBitmap(iCnt);
		pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
		bitmap.DeleteObject();
	}

	CImageList* pImageList1 = new CImageList();
	pImageList1->Create(16, 16, TRUE, 1, 1);

	CReCClientApp *pApp = (CReCClientApp *)AfxGetApp();
	pImageList1->Add(pApp->LoadIcon(IDI_ICON_FILE));

	m_dir_tree.SetImageList(pImageList, TVSIL_NORMAL);
	m_file_list.SetImageList(pImageList1, LVSIL_SMALL);

	DirTree = &m_dir_tree;

	FetchDirList("/",TVI_ROOT);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CL_EXPLORER::OnItemexpandingFileTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	if(	pNMTreeView->hdr.code == TVN_ITEMEXPANDING )
	{
		HTREEITEM hIT = pNMTreeView->itemNew.hItem;
		CString cstr, strPath;

		// build up the path to htreeitem
		strPath = m_dir_tree.GetItemText(hIT);

		while(hIT)
		{
			hIT = m_dir_tree.GetParentItem(hIT);

			/*if (hIT == m_dir_tree.GetRootItem())
				cstr.Format(_T("/%s"), (LPCTSTR)strPath);
			else
				cstr.Format(_T("%s/%s"), (LPCTSTR)m_dir_tree.GetItemText(hIT), (LPCTSTR)strPath);*/

			if(hIT)
				strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;

			//strPath = cstr;
		}
		strPath += "\\*.*";
		FetchDirList(strPath, pNMTreeView->itemNew.hItem);
	}
	else
	{
	}
	*pResult = 0;
}

bool CL_EXPLORER::FetchDirList(CString sz_dir, HTREEITEM hItem)
{
	HTREEITEM hIT = DirTree->GetChildItem(hItem);
	HTREEITEM hTemp;

	if(hIT)
	if(DirTree->GetItemText(hIT) != "DUMMY")
		return true;
	while (hIT != NULL)
	{
		hTemp = DirTree->GetNextSiblingItem(hIT);
		DirTree->DeleteItem(hIT);
		hIT = hTemp;
	}

	CString sz_data;
	sz_data = "FindFile|*|*|";
	sz_data += sz_dir;
	sz_data += "|*|*|";
	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
		return false;
	}

	char sz_file_data[512];
	while(1)
	{
		int n_bytes_to_come;
		int n_int_size = sizeof(int);
		if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
										(void *)&n_bytes_to_come,
										sizeof(int)) < n_int_size)
		{
			CReCClientApp::ShowError();
			return false;
		}
		else
		{
			if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
											sz_file_data,
											n_bytes_to_come) < n_bytes_to_come)
			{
				CReCClientApp::ShowError();
				return false;
			}
			else
			{
				sz_file_data[n_bytes_to_come] = '\0';
				if(stricmp(sz_file_data, "FINISH") == 0)
					break;
				
				CL_FILE_DETAILS file_detail(&sz_file_data[0]);

				if(file_detail.m_is_dir == 0 || file_detail.m_is_dir == 1)
				{
					HTREEITEM ht = DirTree->InsertItem(	file_detail.m_sz_file_name, hItem);
					DirTree->SetItemImage(	ht,
											file_detail.m_is_dir,
											file_detail.m_is_dir);

					HTREEITEM ht_kid = DirTree->InsertItem(	"DUMMY", ht);
					DirTree->SetItemImage(	ht_kid,
											1,
											1);
				}
			}
		}
	}
	DirTree->SortChildren(hItem);
	return true;
}

void CL_EXPLORER::OnSelchangedFileTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	HTREEITEM hIT = pNMTreeView->itemNew.hItem;
	CString cstr, strPath;

	// build up the path to htreeitem
	strPath = m_dir_tree.GetItemText(hIT);

	while(hIT)
	{
		hIT = m_dir_tree.GetParentItem(hIT);

		if(hIT)
			strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;

		//strPath = cstr;
	}
	strPath += "\\*.*";
	FetchFileList(strPath, pNMTreeView->itemNew.hItem);

	*pResult = 0;
}


bool CL_EXPLORER::FetchFileList(CString sz_dir, HTREEITEM hItem)
{
	m_file_list.DeleteAllItems();
	CString sz_data;
	sz_data = "FindFile|*|*|";
	sz_data += sz_dir;
	sz_data += "|*|*|";
	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
		return false;
	}

	char sz_file_data[512];
	while(1)
	{
		int n_bytes_to_come;
		int n_int_size = sizeof(int);
		if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
										(void *)&n_bytes_to_come,
										sizeof(int)) < n_int_size)
		{
			CReCClientApp::ShowError();
			return false;
		}
		else
		{
			if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
											sz_file_data,
											n_bytes_to_come) < n_bytes_to_come)
			{
				CReCClientApp::ShowError();
				return false;
			}
			else
			{
				sz_file_data[n_bytes_to_come] = '\0';
				if(stricmp(sz_file_data, "FINISH") == 0)
					break;
				
				CL_FILE_DETAILS file_detail(&sz_file_data[0]);

				if(file_detail.m_is_dir == 2)
				{
					m_file_list.InsertItem(0, file_detail.m_sz_file_name, 0);
				}
			}
		}
	}
	return true;
}

void CL_EXPLORER::OnCancel() 
{
	CImageList  *pimagelist;
	pimagelist = m_dir_tree.GetImageList(TVSIL_NORMAL);
	if(pimagelist)
		delete pimagelist;

	pimagelist = m_file_list.GetImageList(TVSIL_NORMAL);
	if(pimagelist)
		delete pimagelist;

	CDialog::OnCancel();
}

void CL_EXPLORER::OnRclickFileList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	//For File name
	/*
	int n_sel_mark = m_file_list.GetSelectionMark();
	int n_sel_count = m_file_list.GetSelectedCount();
	if( n_sel_count > 0  && n_sel_mark >= 0)
	{
		CString sz_file_name = m_file_list.GetItemText( n_sel_mark, 0);
		m_sz_file_name = sz_file_name;
	}
	else
	{
		m_sz_file_name = "";
	}
	*/

	NMLISTVIEW* pView = (NMLISTVIEW*)pNMHDR;
	RECT rect,rect1;
	//m_file_list.GetClientRect(&rect);
	m_file_list.GetWindowRect(&rect1);

	CReCClientApp *pApp = (CReCClientApp *)AfxGetApp();
	pApp->m_pMainWnd->GetWindowRect(&rect);
	//pApp->m_pMainWnd->GetClientRect(&rect1);

	CMenu menu;
	menu.LoadMenu(IDR_MENU_CMD_FILE);
	CMenu* pSubMenu = menu.GetSubMenu(0);
	if(pSubMenu)
	pSubMenu->TrackPopupMenu(	TPM_LEFTALIGN | TPM_RIGHTBUTTON,
							rect1.left + pView->ptAction.x,
							rect1.top + pView->ptAction.y,
							this);

	*pResult = 0;
}

void CL_EXPLORER::OnCopy() 
{
	int n_sel_mark = m_file_list.GetSelectionMark();
	int n_sel_count = m_file_list.GetSelectedCount();
	if( n_sel_count > 0  && n_sel_mark >= 0)
	{
		CString sz_file_name = m_file_list.GetItemText( n_sel_mark, 0);
		m_sz_file_name = sz_file_name;
	}
	else
	{
		m_sz_file_name = "";
	}

	// TODO: Add your command handler code here
	b_is_copy = true;
	m_is_cut = false;

	HTREEITEM hIT = m_dir_tree.GetSelectedItem();
	CString strPath;
	strPath = m_dir_tree.GetItemText(hIT);

	while(hIT)
	{
		hIT = m_dir_tree.GetParentItem(hIT);

		if(hIT)
		{
			if(m_dir_tree.GetItemText(hIT) == "\\")
				strPath = "/" + strPath;
			else
				strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;
		}
	}

	m_sz_file_path = strPath;
	m_sz_file_path += "\\" + m_sz_file_name;
}

void CL_EXPLORER::OnCut() 
{
	int n_sel_mark = m_file_list.GetSelectionMark();
	int n_sel_count = m_file_list.GetSelectedCount();
	if( n_sel_count > 0  && n_sel_mark >= 0)
	{
		CString sz_file_name = m_file_list.GetItemText( n_sel_mark, 0);
		m_sz_file_name = sz_file_name;
	}
	else
	{
		m_sz_file_name = "";
	}

	m_is_cut = true;
	b_is_copy = false;

	HTREEITEM hIT = m_dir_tree.GetSelectedItem();
	CString strPath;
	strPath = m_dir_tree.GetItemText(hIT);

	while(hIT)
	{
		hIT = m_dir_tree.GetParentItem(hIT);

		if(hIT)
		{
			if(m_dir_tree.GetItemText(hIT) == "\\")
				strPath = "/" + strPath;
			else
				strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;
		}
	}

	m_sz_file_path = strPath;
	m_sz_file_path += "\\" + m_sz_file_name;
	
}

void CL_EXPLORER::OnPaste() 
{
	HTREEITEM hIT = m_dir_tree.GetSelectedItem();
	CString strPath;
	strPath = m_dir_tree.GetItemText(hIT);

	while(hIT)
	{
		hIT = m_dir_tree.GetParentItem(hIT);

		if(hIT)
		{
			if(m_dir_tree.GetItemText(hIT) == "\\")
				strPath = "/" + strPath;
			else
				strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;
		}
	}
	
	strPath += "\\" + m_sz_file_name;

	CString sz_data;
	if (m_is_cut)
		sz_data = "MoveFile|*|*|";
	else
		sz_data = "CopyFile|*|*|";

	sz_data += m_sz_file_path;
	sz_data += "|*|*|";
	sz_data += strPath;
	sz_data += "|*|*|";


	CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength());

	m_file_list.InsertItem(	m_file_list.GetItemCount(),
							m_sz_file_name,
							0);

}

void CL_EXPLORER::OnClickFileList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
/*	int n_sel_mark = m_file_list.GetSelectionMark();
	int n_sel_count = m_file_list.GetSelectedCount();
	if( n_sel_count > 0  && n_sel_mark >= 0)
	{
		CString sz_file_name = m_file_list.GetItemText( n_sel_mark, 0);
		m_sz_file_name = sz_file_name;
	}
	else
	{
		m_sz_file_name = "";
	}
	*pResult = 0;
*/
}

void CL_EXPLORER::OnMainDelete() 
{
	int n_sel_mark = m_file_list.GetSelectionMark();
	int n_sel_count = m_file_list.GetSelectedCount();
	if( n_sel_count > 0  && n_sel_mark >= 0)
	{
		CString sz_file_name = m_file_list.GetItemText( n_sel_mark, 0);
		m_sz_file_name = sz_file_name;
	}
	else
	{
		m_sz_file_name = "";
	}


	HTREEITEM hIT = m_dir_tree.GetSelectedItem();
	CString strPath;
	strPath = m_dir_tree.GetItemText(hIT);

	while(hIT)
	{
		hIT = m_dir_tree.GetParentItem(hIT);

		if(hIT)
		{
			if(m_dir_tree.GetItemText(hIT) == "\\")
				strPath = "/" + strPath;
			else
				strPath = m_dir_tree.GetItemText(hIT) + "\\" + strPath;
		}
	}
	
	strPath += "\\" + m_sz_file_name;

	CString sz_data;
	sz_data = "DeleteFile|*|*|";

	sz_data += strPath;
	sz_data += "|*|*|";


	CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength());

	m_file_list.DeleteItem(m_file_list.GetSelectionMark());
}

void CL_EXPLORER::OnBtnRefresh() 
{
	m_dir_tree.DeleteAllItems();
	m_file_list.DeleteAllItems();
	FetchDirList("/",TVI_ROOT);
}

void CL_EXPLORER::OnBtnCopyFrom() 
{
	CL_COPY_PASTE cp_dlg(COPY);
	
	if (cp_dlg.DoModal() == IDOK)
	{
		m_sz_file_path = cp_dlg.m_path;
		int n_pos = m_sz_file_path.ReverseFind('\\');
		if (n_pos < 0)
		{
			AfxMessageBox("Wrong path specified.\nYou need to specify full path");
			return;
		}
		m_sz_file_name = m_sz_file_path.Right(m_sz_file_path.GetLength() - n_pos - 1);
	}
}

void CL_EXPLORER::OnBtnPasteTo() 
{
	CL_COPY_PASTE paste_dlg(PASTE);

	if (paste_dlg.DoModal() == IDOK)
	{
		CString sz_data;
		if (m_is_cut)
			sz_data = "MoveFile|*|*|";
		else
			sz_data = "CopyFile|*|*|";

		sz_data += m_sz_file_path;
		sz_data += "|*|*|";
		sz_data += paste_dlg.m_path;
		sz_data += "|*|*|";


		CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength());
	}
}
