/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// L_TASK_MANAGER.cpp : implementation file
//

#include "stdafx.h"
#include "ReCClient.h"
#include "L_TASK_MANAGER.h"
#include "L_GENERIC_SOCKET.h"
#include "L_PROCESS_DETAILS.h"
#include "L_SHUT.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SOCKET g_sock_client;
extern bool g_is_connected;
/////////////////////////////////////////////////////////////////////////////
// CL_TASK_MANAGER dialog


CL_TASK_MANAGER::CL_TASK_MANAGER(CWnd* pParent /*=NULL*/)
	: CDialog(CL_TASK_MANAGER::IDD, pParent)
{
	//{{AFX_DATA_INIT(CL_TASK_MANAGER)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CL_TASK_MANAGER::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CL_TASK_MANAGER)
	DDX_Control(pDX, IDC_TASK_LIST, m_task_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CL_TASK_MANAGER, CDialog)
	//{{AFX_MSG_MAP(CL_TASK_MANAGER)
	ON_BN_CLICKED(IDC_BTN_TERMINATE, OnBtnTerminate)
	ON_BN_CLICKED(IDC_BTN_LOGOFF, OnBtnLogoff)
	ON_BN_CLICKED(IDC_BTN_SHUTDOWN, OnBtnShutdown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CL_TASK_MANAGER message handlers

void CL_TASK_MANAGER::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CL_TASK_MANAGER::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_task_list.SetExtendedStyle(LVS_EX_FULLROWSELECT);// | LVS_EX_GRIDLINES);
	m_task_list.InsertColumn(0,"Process Name",LVCFMT_LEFT,193);
	m_task_list.InsertColumn(1,"Process Id",LVCFMT_LEFT,75);
	FetchProcList();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CL_TASK_MANAGER::OnBtnTerminate() 
{
	int n_sel = m_task_list.GetSelectionMark();
	if(n_sel >= 0)
	{
		CString sz_pid = m_task_list.GetItemText(n_sel, 1);
		CString sz_data = "KillProcess|*|*|";
		sz_data += sz_pid;
		sz_data += "|*|*|";
		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			CReCClientApp::ShowError();
			CDialog::OnOK();
		}
	}
	Sleep(1000);
	if(!FetchProcList())
		CDialog::OnOK();
}

void CL_TASK_MANAGER::OnBtnLogoff() 
{
	CString sz_data = "Logoff|*|*|";

	if (AfxMessageBox("Are you sure you want current user to be logged off?", MB_ICONQUESTION | MB_YESNO) == IDYES)
	{
		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			CReCClientApp::ShowError();
			CDialog::OnOK();
		}
	}
}

void CL_TASK_MANAGER::OnBtnShutdown() 
{
	CL_SHUT shut_dlg;
	CString sz_data;

	if (shut_dlg.DoModal() == IDOK)
	{
		if (shut_dlg.m_shut == 0)
			sz_data = "ShutDown|*|*|";
		else
			sz_data = "Reboot|*|*|";

		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			CReCClientApp::ShowError();
			CDialog::OnOK();
		}
	}
}


//DEL void CL_TASK_MANAGER::ShowError()
//DEL {
//DEL 	
//DEL }


bool CL_TASK_MANAGER::FetchProcList()
{
	m_task_list.DeleteAllItems();
	CString sz_data;
	sz_data = "GetProcList|*|*|";
	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
		return false;
	}

	char sz_proc_data[512];
	while(1)
	{
		int n_bytes_to_come;
		int n_int_size = sizeof(int);
		if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
										(void *)&n_bytes_to_come,
										sizeof(int)) < n_int_size)
		{
			CReCClientApp::ShowError();
			return false;
		}
		else
		{
			if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
											sz_proc_data,
											n_bytes_to_come) < n_bytes_to_come)
			{
				CReCClientApp::ShowError();
				return false;
			}
			else
			{
				sz_proc_data[n_bytes_to_come] = '\0';
				if(stricmp(sz_proc_data, "FINISH") == 0)
					break;
				CL_PROCESS_DETAILS proc_detail(sz_proc_data);
				int x = m_task_list.GetSelectedCount();
				char sz_str[100];
				m_task_list.InsertItem(0,proc_detail.m_sz_process_name);
				m_task_list.SetItemText(0,1,itoa(proc_detail.m_n_process_id, sz_str, 10));
			}
		}
	}
	m_task_list.SetFocus();
	m_task_list.SetItemState( 0, LVIS_SELECTED, LVIS_SELECTED);
	m_task_list.SetSelectionMark(0);	
	(GetDlgItem(IDC_BTN_TERMINATE))->EnableWindow(FALSE);
	if(m_task_list.GetSelectedCount() > 0)
	{
		(GetDlgItem(IDC_BTN_TERMINATE))->EnableWindow(TRUE);
	}
	return true;
}
